import { Edition } from "@/data/edition";
import { EditionAction, EditionActions } from "@/state/actions/edition";
import { editionSerializationTransformer, Serializable } from "@/serialization";

export type EditionState = Serializable<Edition> | null;

const initialEditionState: EditionState = null;

const editionReducer = (state: EditionState = initialEditionState, action: EditionAction): EditionState => {
    switch (action.type) {
        case EditionActions.Set:
            return editionSerializationTransformer.transform(action.edition);
    }

    return state;
}

export default editionReducer;
